Fix bug 1559 to update installers and manifests for Release TEN
[osm/devops.git] / installers / install_osm.sh
1 #!/bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15 REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
16 RELEASE=ReleaseTEN
17 REPOSITORY=stable
18 DOCKER_TAG=10
19 DEVOPS_PATH=/usr/share/osm-devops
20
21 function usage(){
22 echo -e "usage: $0 [OPTIONS]"
23 echo -e "Install OSM from binaries or source code (by default, from binaries)"
24 echo -e " OPTIONS"
25 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
27 echo -e " -r <repo>: use specified repository name for osm packages"
28 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
29 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
31 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
32 echo -e " -b master (main dev branch)"
33 echo -e " -b v2.0 (v2.0 branch)"
34 echo -e " -b tags/v1.1.0 (a specific tag)"
35 echo -e " ..."
36 echo -e " -c <orchestrator> deploy osm services using container <orchestrator>. Valid values are <k8s> or <swarm>. If -c is not used then osm will be deployed using default orchestrator. When used with --uninstall, osm services deployed by the orchestrator will be uninstalled"
37 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
38 echo -e " -H <VCA host> use specific juju host controller IP"
39 echo -e " -S <VCA secret> use VCA/juju secret key"
40 echo -e " -P <VCA pubkey> use VCA/juju public key file"
41 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
42 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
43 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
44 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
45 echo -e " --pla: install the PLA module for placement support"
46 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, PLA, NONE)"
47 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
48 echo -e " -O <openrc file/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
49 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
50 echo -e " -D <devops path> use local devops installation path"
51 echo -e " -w <work dir> Location to store runtime installation"
52 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
53 echo -e " -l: LXD cloud yaml file"
54 echo -e " -L: LXD credentials yaml file"
55 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
56 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
57 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
58 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
59 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
60 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
61 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
62 echo -e " --nojuju: do not juju, assumes already installed"
63 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
64 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
65 echo -e " --nohostclient: do not install the osmclient"
66 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
67 echo -e " --source: install OSM from source code using the latest stable tag"
68 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
69 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
70 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
71 echo -e " --volume: create a VM volume when installing to OpenStack"
72 echo -e " --showopts: print chosen options and exit (only for debugging)"
73 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
74 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
75 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
76 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
77 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
78 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
79 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
80 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
81 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
82 echo -e " [--tag]: Docker image tag. (--charmed option)"
83 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
84
85 }
86
87 add_repo() {
88 REPO_CHECK="^$1"
89 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
90 if [ $? -ne 0 ]
91 then
92 need_packages_lw="software-properties-common apt-transport-https"
93 echo -e "Checking required packages: $need_packages_lw"
94 dpkg -l $need_packages_lw &>/dev/null \
95 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
96 || sudo apt-get -q update \
97 || ! echo "failed to run apt-get update" \
98 || exit 1
99 dpkg -l $need_packages_lw &>/dev/null \
100 || ! echo -e "Installing $need_packages_lw requires root privileges." \
101 || sudo apt-get install -y $need_packages_lw \
102 || ! echo "failed to install $need_packages_lw" \
103 || exit 1
104 wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add -
105 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update
106 return 0
107 fi
108
109 return 1
110 }
111
112 clean_old_repo() {
113 dpkg -s 'osm-devops' &> /dev/null
114 if [ $? -eq 0 ]; then
115 # Clean the previous repos that might exist
116 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
117 fi
118 }
119
120 while getopts ":b:r:c:n:k:u:R:l:L:K:p:D:o:O:m:N:H:S:s:w:t:U:P:A:d:p:f:F:-: hy" o; do
121 case "${o}" in
122 D)
123 DEVOPS_PATH="${OPTARG}"
124 ;;
125 r)
126 REPOSITORY="${OPTARG}"
127 ;;
128 R)
129 RELEASE="${OPTARG}"
130 ;;
131 u)
132 REPOSITORY_BASE="${OPTARG}"
133 ;;
134 t)
135 DOCKER_TAG="${OPTARG}"
136 ;;
137 -)
138 [ "${OPTARG}" == "help" ] && usage && exit 0
139 ;;
140 :)
141 echo "Option -$OPTARG requires an argument" >&2
142 usage && exit 1
143 ;;
144 \?)
145 echo -e "Invalid option: '-$OPTARG'\n" >&2
146 usage && exit 1
147 ;;
148 h)
149 usage && exit 0
150 ;;
151 *)
152 ;;
153 esac
154 done
155
156 clean_old_repo
157 add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
158 sudo DEBIAN_FRONTEND=noninteractive apt-get -q update
159 sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops
160 $DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"